const Main         = imports.ui.main;
const Shell        = imports.gi.Shell;
const PopupMenu    = imports.ui.popupMenu;
const Me           = imports.misc.extensionUtils.getCurrentExtension();

const Convenience = Me.imports.convenience;
const Prefs       = Me.imports.prefs;

let items    = [];

function init() {
}

function enable() {
    let entries = Prefs.getMovedApps();
    for (let i = 0; i < entries.length; ++i){
	    let app = Shell.AppSystem.get_default().lookup_app(entries[i]);
	    items[i] = new PopupMenu.PopupMenuItem(app.get_name());
	    items[i].connect('activate', function () {
	        Main.overview.hide();
	        app.activate();
	    });
    }

    let userMenu = Main.panel.statusArea.userMenu.menu;

    let position = 3;
    let currentItems = userMenu._getMenuItems();
    for (let i = 0; i < items.length; ++i) {
        if (currentItems[i] instanceof PopupMenu.PopupSeparatorMenuItem) {
            position = i + 1;
            break;
        }
    }
    for (let i = 0; i < items.length; ++i) {
	    userMenu.addMenuItem(items[i], i + position);
    }
}

function disable() {
    for (let i = 0; i < items.length; ++i) {
	    items[i].destroy();
    }

    items = [];
}
